﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics.Controls.Grids;
using System.Collections.ObjectModel;
using System.Windows.Browser;

namespace XamGridBugDemo
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
            TestData.Instance.ComboAList.Add("10");
            TestData.Instance.ComboAList.Add("20");
            TestData.Instance.ComboAList.Add("30");
            TestData.Instance.ComboAList.Add("40");
            TestGrid.ItemsSource = new ObservableCollection<DataRow>();
        }

        private string[] masterBList  = new string[] {"100", "101", "203", "208", "204", "306", "401"};

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            TestGrid.ItemsSource = new List<DataRow>(new DataRow[] { new DataRow { A = "1", B = "2" }, new DataRow { A = "1", B = "2" }, new DataRow { A = "1", B = "2" } });
        }

        private void ComboBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            TestData.Instance.ComboBList.Clear();

            if (e.AddedItems.Count > 0)
            {
                foreach (string str in masterBList.Where(s => s.StartsWith(e.AddedItems[0].ToString())))
                    TestData.Instance.ComboBList.Add(str);
            }
        }

        private void TestGrid_RowAdded(object sender, RowEventArgs e)
        {
            MessageBox.Show("RowAdded value present: " + e.Row.Cells[1].Value);
        }

        private void TestGrid_RowExitedEditMode(object sender, EditingRowEventArgs e)
        {
            MessageBox.Show("RowExited value present: " + e.Row.Cells[1].Value);
        }

        private void TestGrid_CellExitingEditMode(object sender, ExitEditingCellEventArgs e)
        {
            MessageBox.Show("CellExiting NewValue present:" + e.NewValue);
        }
    }

    public class DataRow
    {
        public string A { get; set; }
        public string B { get; set; }
        public string C { get; set; }
    }

    public class TestData
    {
        public ObservableCollection<string> ComboAList { get { return _instance.comboAList; } }
        public ObservableCollection<string> ComboBList { get { return _instance.comboBList; } }

        private ObservableCollection<string> comboAList;
        private ObservableCollection<string> comboBList;
        private static TestData _instance = new TestData();

        public static TestData Instance { get { return _instance; } }

        public TestData()
        {
            if (_instance == null)
            {
                this.comboAList = new ObservableCollection<string>();
                this.comboBList = new ObservableCollection<string>();
            }
        }
    }
}
